Attribute VB_Name = "modCalculPur"
Option Explicit

' Dfinition d'une plaque
Type Plaque
    Nb As Long          ' Nombre associ  la plaque
    Op As String        ' Oprateur associ a la plaque
    Pos As Long         ' Position d'ordre dans le calcul du compte est bon
End Type

Type Decompose
    N(25) As Long
End Type

Public Declare Function LanceTirage Lib "C:\Tirage.dll" Alias "#1" (ByVal P1 As Long, ByVal P2 As Long, ByVal P3 As Long, _
                                    ByVal P4 As Long, ByVal P5 As Long, ByVal P6 As Long, ByVal P7 As Long) As Integer

Global Tirage(6) As Plaque
Global nbUtil As Long
Public Function CompteBon(inPos As Long) As Boolean
Dim inTMP As Long
inTMP = inPos
If Tirage(0).Nb = 0 Then
    CompteBon = True            ' On trouve le compte
    Exit Function
End If
If nbUtil = 7 Then
    CompteBon = False           ' On ne peut plus avancer
    Exit Function
End If

Do While inTMP <= 6
    If (Tirage(inTMP).Op = "") Then
        If SoustraitPossible(inTMP) Then
            Call Soustraction(inTMP)
                CompteBon = CompteBon(1)
                If CompteBon Then Exit Function
            Call RetireSoustraction(inTMP)
        End If
        
        If DivisePossible(inTMP) Then
            Call Division(inTMP)
                CompteBon = CompteBon(1)
                If CompteBon Then Exit Function
            Call RetireDivision(inTMP)
        End If
        
        Call Addition(inTMP)
            CompteBon = CompteBon(1)
            If CompteBon Then Exit Function
        Call RetireAddition(inTMP)
        
        Call Multiplication(inTMP)
            CompteBon = CompteBon(1)
            If CompteBon Then Exit Function
        Call RetireMultiplication(inTMP)
    
    End If
    inTMP = inTMP + 1
Loop
CompteBon = False
End Function
Public Sub Addition(inPlaque As Long)
' Additionne le nombre de la plaque donne en paramtre au nombre total
' ---
' Affecte le numro d'ordre  la plaque
Tirage(inPlaque).Pos = nbUtil
' Incrmente le numro d'ordre pour la plaque suivante
nbUtil = nbUtil + 1
' Affecte le signe inverse de l'opration  la plaque
Tirage(inPlaque).Op = "-"
' Enfin, enregistre le nouveau compte  trouver
Tirage(0).Nb = Tirage(0).Nb + Tirage(inPlaque).Nb
End Sub
Public Sub Soustraction(inPlaque As Long)
' Soustrait le nombre de la plaque donne en paramtre au nombre total
' ---
Tirage(inPlaque).Pos = nbUtil
nbUtil = nbUtil + 1
Tirage(inPlaque).Op = "+"
Tirage(0).Nb = Tirage(0).Nb - Tirage(inPlaque).Nb
End Sub
Public Sub Multiplication(inPlaque As Long)
' Multiplie le nombre de la plaque donne en paramtre au nombre total
' ---
Tirage(inPlaque).Pos = nbUtil
nbUtil = nbUtil + 1
Tirage(inPlaque).Op = "/"
Tirage(0).Nb = Tirage(0).Nb * Tirage(inPlaque).Nb
End Sub
Public Sub Division(inPlaque As Long)
' Divise le nombre de la plaque donne en paramtre au nombre total
' ---
Tirage(inPlaque).Pos = nbUtil
nbUtil = nbUtil + 1
Tirage(inPlaque).Op = "*"
Tirage(0).Nb = Tirage(0).Nb / Tirage(inPlaque).Nb
End Sub
Public Sub RetireAddition(inPlaque As Long)
' Retire une addition faite  partir de la plaque donne en paramtre
' ---
' Remet  zro le numro d'ordre de la plaque
Tirage(inPlaque).Pos = 0
' Dcrmente le numro d'ordre de la plaque suivante
nbUtil = nbUtil - 1
' Remet  vide l'oprateur associ  la plaque
Tirage(inPlaque).Op = ""
' Enfin, retire l'addition du compte  touver
Tirage(0).Nb = Tirage(0).Nb - Tirage(inPlaque).Nb
End Sub
Public Sub RetireSoustraction(inPlaque As Long)
' Retire une soustraction faite  partir de la plaque donne en paramtre
' ---
Tirage(inPlaque).Pos = 0
nbUtil = nbUtil - 1
Tirage(inPlaque).Op = ""
Tirage(0).Nb = Tirage(0).Nb + Tirage(inPlaque).Nb
End Sub
Public Sub RetireMultiplication(inPlaque As Long)
' Retire une multiplication faite  partir de la plaque donne en paramtre
' ---
Tirage(inPlaque).Pos = 0
nbUtil = nbUtil - 1
Tirage(inPlaque).Op = ""
Tirage(0).Nb = Tirage(0).Nb / Tirage(inPlaque).Nb
End Sub
Public Sub RetireDivision(inPlaque As Long)
' Retire une division faite  partir de la plaque donne en paramtre
' ---
Tirage(inPlaque).Pos = 0
nbUtil = nbUtil - 1
Tirage(inPlaque).Op = ""
Tirage(0).Nb = Tirage(0).Nb * Tirage(inPlaque).Nb
End Sub
Public Function SoustraitPossible(inPlaque As Long) As Boolean
' Teste si une soustraction avec la plaque donne en paramtre est possible,
' Il faut que la diffrence avec le compte  trouver soit suprieur (ou gal, c'est encore mieux)  zro
SoustraitPossible = ((Tirage(0).Nb - Tirage(inPlaque).Nb) >= 0)
End Function
Public Function DivisePossible(inPlaque As Long) As Boolean
' Teste si une division avec la plaque donne en paramtre est possible,
Dim sgTMP As Single
sgTMP = (Tirage(0).Nb / Tirage(inPlaque).Nb)
' Il faut que la division donne un rsultat entier, et que la plaque ne soit pas gal  1. Cela vite de gaspiller une
' plaque pour un calcul qui ne sert  rien.
DivisePossible = ((sgTMP >= 1) And (sgTMP = Int(sgTMP)) And (Tirage(inPlaque).Nb <> 1))
End Function
Private Sub EffaceFeuille(frmFeuille As Form)
Dim cItem As Control
For Each cItem In frmFeuille.Controls
    If TypeOf cItem Is TextBox Then
        cItem.Text = ""
    ElseIf TypeOf cItem Is ComboBox Then
        If cItem.Style = 2 Then cItem.ListIndex = -1 Else cItem = ""
    End If
Next
End Sub
